/**           __  __
 *    _____ _/ /_/ /_    Computational Intelligence Library (CIlib)
 *   / ___/ / / / __ \   (c) CIRG @ UP
 *  / /__/ / / / /_/ /   http://cilib.net
 *  \___/_/_/_/_.___/
 */

/**
 * <p>
 * Collection of different types of functions. The function classes are categorized into
 * different types:
 *
 * <ul>
 *   <li>Continuous functions</li>
 *   <li>Discrete functions</li>
 *   <li>Clustering functions</li>
 * </ul>
 *
 * <p>
 * Each function provides details about itself within the JavaDoc. For example, continuous
 * functions state the function properties such as:
 *
 * <ul>
 *   <li>Multi or Unimodal</li>
 *   <li>Continuous or discontinuous</li>
 *   <li>Separable or Non-separable</li>
 *   <li>Input values for the the global minimum / maximum, if it is known.</li>
 *   <li>The accepted search space domain of the function for benchmark purposes.</li>
 * </ul>
 */
package net.sourceforge.cilib.functions;
